package io.reisub.dreambot.cashminer.tasks;

import io.reisub.dreambot.util.Constants;
import io.reisub.dreambot.util.Util;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.interactive.GameObjects;
import org.dreambot.api.methods.map.Area;
import org.dreambot.api.methods.map.Tile;
import org.dreambot.api.methods.walking.impl.Walking;
import org.dreambot.api.script.TaskNode;
import org.dreambot.api.wrappers.interactive.GameObject;

public class Mine extends TaskNode {
    private final Area AREA = new Area(
            new Tile(3787, 3767, 0),
            new Tile(3787, 3775, 0),
            new Tile(3803, 3775, 0),
            new Tile(3802, 3765, 0));

    @Override
    public boolean accept() {
        GameObject pile = GameObjects.closest(gameObject -> AREA.contains(gameObject) && gameObject.getName().equals("Ash pile"));
        if (pile != null && pile.distance() < 3) {
            return !Inventory.isFull()
                    && Util.playerIsIdle(1200);
        } else {
            return !Inventory.isFull()
                    && Util.playerIsIdle();
        }
    }

    @Override
    public int execute() {
        GameObject pile = GameObjects.closest(gameObject -> AREA.contains(gameObject) && gameObject.getName().equals("Ash pile"));
        if (pile == null) return Calculations.random(250, 400);

        if (!pile.isOnScreen()) {
            if (Walking.shouldWalk(Calculations.random(4, 6))) {
                Walking.walk(pile);
            }

            Util.sleepUntilMoving();
            return Calculations.random(250, 400);
        }

        pile.interactForceLeft(Constants.MINE);
        Util.sleepUntilMovingAndAnimating();

        return Calculations.random(250, 400);
    }
}
