package io.reisub.dreambot.cminer;

import io.reisub.dreambot.cminer.tasks.*;
import io.reisub.dreambot.util.CTaskScript;
import io.reisub.dreambot.util.Constants;
import io.reisub.dreambot.util.randomevents.GenieSolver;
import io.reisub.dreambot.util.tasks.Run;
import io.reisub.dreambot.util.tasks.kitten.KittenTask;
import org.dreambot.api.methods.skills.Skill;
import org.dreambot.api.script.Category;
import org.dreambot.api.script.ScriptManifest;
import org.dreambot.api.script.TaskNode;

@ScriptManifest(category = Category.MINIGAME, name = "CMiner", description = "Diggy diggy hole", author = Constants.AUTHOR, version = 1.0)
public class CMiner extends CTaskScript {
    @Override
    public void onStart() {
        getRandomManager().registerSolver(new GenieSolver(GenieSolver.Skill.HERBLORE));

        getUI().addSkills(Skill.MINING);
        getUI().addSkills(Skill.MAGIC);

        TaskNode kittenTask = KittenTask.getInstance();
        if (kittenTask != null) {
            addNodes(kittenTask);
        }

        addNodes(
                new Run(),
                new GoToSpot(),
                new Superheat(),
                new Mine(true),
                new GoToBank(),
                new OpenBank(),
                new DoBank(),
                new Teleport()
        );
    }
}
