package io.reisub.dreambot.cminer.tasks;

import io.reisub.dreambot.util.Constants;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.MethodProvider;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.container.impl.bank.Bank;
import org.dreambot.api.methods.container.impl.equipment.Equipment;
import org.dreambot.api.methods.interactive.Players;
import org.dreambot.api.methods.map.Area;
import org.dreambot.api.methods.map.Tile;
import org.dreambot.api.methods.tabs.Tab;
import org.dreambot.api.methods.tabs.Tabs;
import org.dreambot.api.script.TaskNode;
import org.dreambot.api.wrappers.items.Item;

public class Teleport extends TaskNode {
    private final Area TELEPORT_AREA = new Area(
            new Tile(2599, 3216, 0),
            new Tile(2613, 3216, 0),
            new Tile(2613, 3227, 0),
            new Tile(2599, 3227, 0));

    @Override
    public boolean accept() {
        return GoToBank.BANK_AREA.contains(Players.localPlayer()) &&
                !Inventory.isFull() &&
                (Inventory.contains(Constants.ARDOUGNE_CLOAK_FILTER) || Equipment.contains(Constants.ARDOUGNE_CLOAK_FILTER));
    }

    @Override
    public int execute() {
        if (Bank.isOpen()) {
            Bank.close();
            if (!MethodProvider.sleepUntil(() -> !Bank.isOpen(), Calculations.random(1800, 2100))) {
                return Calculations.random(250, 400);
            }
        }

        Item cloak;

        if (Inventory.contains(Constants.ARDOUGNE_CLOAK_FILTER)) {
            cloak = Inventory.get(Constants.ARDOUGNE_CLOAK_FILTER);
            if (!Tabs.isOpen(Tab.INVENTORY)) {
                Tabs.open(Tab.INVENTORY);
            }
        } else {
            cloak = Equipment.get(Constants.ARDOUGNE_CLOAK_FILTER);
            if (!Tabs.isOpen(Tab.EQUIPMENT)) {
                Tabs.open(Tab.EQUIPMENT);
            }
        }

        if (cloak != null) {
            cloak.interact(Constants.MONASTERY_TELEPORT);
            MethodProvider.sleepUntil(() -> TELEPORT_AREA.contains(Players.localPlayer()), Calculations.random(4000, 5000));
        }

        return Calculations.random(250, 400);
    }
}
