package io.reisub.dreambot.cplanker.tasks;

import io.reisub.dreambot.util.Constants;
import io.reisub.dreambot.util.Util;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.MethodProvider;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.filter.Filter;
import org.dreambot.api.methods.interactive.GameObjects;
import org.dreambot.api.methods.map.Area;
import org.dreambot.api.methods.map.Tile;
import org.dreambot.api.script.TaskNode;
import org.dreambot.api.wrappers.interactive.GameObject;

public class Chop extends TaskNode {
    private final Area AREA = new Area(
            new Tile(3288, 3498, 0),
            new Tile(3288, 3486, 0),
            new Tile(3295, 3481, 0),
            new Tile(3298, 3492, 0),
            new Tile(3293, 3499, 0));

    @Override
    public boolean accept() {
        return !Inventory.isFull()
                && findTree() != null
                && Util.playerIsIdle();
    }

    @Override
    public int execute() {
        GameObject tree = findTree();
        if (tree == null) return Calculations.random(250, 400);

        tree.interact("Chop down");
        Util.sleepUntilMovingAndAnimating();

        return Calculations.random(250, 400);
    }

    private GameObject findTree() {
        return GameObjects.closest(gameObject -> AREA.contains(gameObject) && gameObject.getName().equals("Oak"));
    }
}
