package io.reisub.dreambot.cplanker.tasks;

import io.reisub.dreambot.util.Util;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.MethodProvider;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.container.impl.bank.Bank;
import org.dreambot.api.methods.interactive.GameObjects;
import org.dreambot.api.methods.interactive.NPCs;
import org.dreambot.api.script.TaskNode;
import org.dreambot.api.wrappers.interactive.GameObject;

public class OpenBank extends TaskNode {
    @Override
    public boolean accept() {
        return Inventory.contains("Oak plank")
                && !Bank.isOpen()
                && NPCs.closest("Sawmill operator") == null;
    }

    @Override
    public int execute() {
        GameObject bank = GameObjects.closest("Bank chest");
        if (bank == null) return Calculations.random(250, 400);

        bank.interactForceLeft("Use");
        if (!Util.sleepUntilMoving()) return Calculations.random(250, 400);

        MethodProvider.sleepUntil(Bank::isOpen, Calculations.random(4000, 4500));

        return Calculations.random(250, 400);
    }
}
