package io.reisub.dreambot.cshopper.tasks;

import io.reisub.dreambot.cshopper.CShopper;
import io.reisub.dreambot.cshopper.ItemWrapper;
import org.dreambot.api.Client;
import org.dreambot.api.data.GameState;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.MethodProvider;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.container.impl.Shop;
import org.dreambot.api.methods.skills.Skills;
import org.dreambot.api.methods.world.World;
import org.dreambot.api.methods.world.Worlds;
import org.dreambot.api.methods.worldhopper.WorldHopper;
import org.dreambot.api.script.TaskNode;

import java.util.Comparator;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

public class Hop extends TaskNode {
    private final Queue<World> worlds;

    public Hop(boolean members) {
        List<World> worldsList = Worlds.all(world -> world.isMembers() == members && world.isNormal() && !world.isHighRisk() && !world.isPVP() && world.getMinimumLevel() <= Skills.getTotalLevel());
        worldsList.sort(Comparator.comparingInt(World::getWorld));

        worlds = new LinkedList<>(worldsList);

        while (true) {
            World w = worlds.poll();
            worlds.add(w);

            if (w == null || w.getWorld() == Worlds.getCurrentWorld()) break;
        }
    }

    public Hop() {
        this(true);
    }

    @Override
    public boolean accept() {
        if (!Shop.isOpen()) return false;

        for (ItemWrapper iw : CShopper.getConfiguration().getItems()) {
            int shopCount = Shop.get(iw.getName()).getAmount();

            int inventoryCount = 0;
            if (Inventory.get(iw.getName()) != null) {
                inventoryCount = Inventory.get(iw.getName()).getAmount();
            }

            if (shopCount > iw.getMinimumInShop() && inventoryCount < iw.getBuyTotal()) return false;
        }

        return true;
    }

    @Override
    public int execute() {
        Shop.close();
        MethodProvider.sleepUntil(() -> !Shop.isOpen(), Calculations.random(2000, 2500));

        World world = worlds.poll();
        worlds.add(world);

        if (world != null) {
            WorldHopper.hopWorld(world);
        }

        MethodProvider.sleepUntil(() -> Client.getGameState() == GameState.LOGGED_IN, Calculations.random(10000, 11000));

        return Calculations.random(200, 400);
    }
}
