package io.reisub.dreambot.cthiever.tasks;

import io.reisub.dreambot.util.Util;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.interactive.NPCs;
import org.dreambot.api.methods.interactive.Players;
import org.dreambot.api.script.ScriptManager;
import org.dreambot.api.script.TaskNode;
import org.dreambot.api.script.listener.ChatListener;
import org.dreambot.api.wrappers.interactive.NPC;
import org.dreambot.api.wrappers.widgets.message.Message;

public class Pickpocket extends TaskNode {
    private boolean attempt, failed, stole;

    public Pickpocket() {
        ScriptManager.getScriptManager().addListener(new ChatListener() {
            @Override
            public void onMessage(Message message) {
                if (message.getMessage().startsWith("You attempt")) {
                    attempt = true;
                    stole = false;
                } else if (message.getMessage().startsWith("You fail")) {
                    failed = true;
                } else if (message.getMessage().startsWith("You steal")) {
                    stole = true;
                }
            }
        });
    }

    @Override
    public boolean accept() {
        NPC target = NPCs.closest("Master farmer");
        return (Util.playerIsIdle() || stole)
                && !(Players.localPlayer().isInCombat() && Players.localPlayer().getInteractingCharacter() != null)
                && Players.localPlayer().getRenderableHeight() != 1000
                && target != null
                && target.isOnScreen();
    }

    @Override
    public int execute() {
        NPC target = NPCs.closest("Master farmer");
        if (target == null) return Calculations.random(250, 400);

        target.interact("Pickpocket");
        Util.sleepUntilMovingOrAnimating();

        return Calculations.random(250, 400);
    }
}
