package io.reisub.dreambot.util.tasks.kitten;

import io.reisub.dreambot.util.CInventory;
import io.reisub.dreambot.util.Constants;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.MethodContext;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.filter.Filter;
import org.dreambot.api.script.TaskNode;
import org.dreambot.api.wrappers.items.Item;

public class CutFoodForKitten extends TaskNode {
    private final KittenTask parent;

    private final Filter<Item> cutFishItemFilter = item -> {
        for (String fishName : Constants.BARBARIAN_FISH_NAMES) {
            if (item.getName().contains(fishName)) {
                return true;
            }
        }

        return false;
    };

    public CutFoodForKitten(KittenTask parent) {
        this.parent = parent;
    }

    @Override
    public boolean accept() {
        return parent.isHungry() &&
                !Inventory.contains(parent.fishItemFilter) &&
                Inventory.contains(cutFishItemFilter) &&
                Inventory.contains(Constants.KNIFE);
    }

    @Override
    public int execute() {
        int count = Inventory.count(cutFishItemFilter);

        CInventory.useOnNearest(Constants.KNIFE, Constants.BARBARIAN_FISH_NAMES);

        MethodContext.sleepUntil(() -> Inventory.count(cutFishItemFilter) < count, Calculations.random(2500, 3000));

        return Calculations.random(250, 400);
    }
}
